using System;
using System.Windows.Forms;
using Syncfusion.Collections.BinaryTree;
using Syncfusion.Grouping;

namespace GroupingWithDataGrid
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Form2 : Form
    {
        private Engine groupingEngine;
        private Engine summaryEngine;
        private TradeList tradeList;
        private RecapList recapList;
		private Label label2;
        private Label label3;
		private Label AvgPrice;
        private Label TotalShares;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl tradeGrid;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl recapGrid;
        private Syncfusion.Windows.Forms.Tools.IntegerTextBox sharesTextBox;
        private Syncfusion.Windows.Forms.Tools.CurrencyTextBox priceTextBox;
        private Label label4;
        private Label label5;
        private Button buttonAdd;
        private GroupBox groupBox1;
        private GroupBox groupBox2;
        private Label label1;
        private Label label6;
        private Label label7;
        private Syncfusion.Windows.Forms.Tools.RadioButtonAdv radioButtonInactive;
        private Syncfusion.Windows.Forms.Tools.RadioButtonAdv radioButtonNeutral;
        private Syncfusion.Windows.Forms.Tools.RadioButtonAdv radioButtonActive;
		private System.ComponentModel.Container components = null;

		public Form2()
		{
            //create the lists
            tradeList = new TradeList();
            recapList = new RecapList();
		    
		    //create engine
            groupingEngine = new Engine();
            summaryEngine = new Engine();

            SetupGroupingEngine();
            SetupSummaryEngine();
			InitializeComponent();
            SubscribeToEvents();
            PopulateData();
    	}
	    
	    #region Windows Form Designer generated code

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form2());
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
                
	    /// <summary>
	    /// Required method for Designer support - do not modify
	    /// the contents of this method with the code editor.
	    /// </summary>
	    private void InitializeComponent()
	    {
            this.AvgPrice = new System.Windows.Forms.Label();
            this.TotalShares = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.tradeGrid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.recapGrid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.sharesTextBox = new Syncfusion.Windows.Forms.Tools.IntegerTextBox();
            this.priceTextBox = new Syncfusion.Windows.Forms.Tools.CurrencyTextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.buttonAdd = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.radioButtonInactive = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.radioButtonNeutral = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.radioButtonActive = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.tradeGrid)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.recapGrid)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.sharesTextBox)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.priceTextBox)).BeginInit();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonInactive)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonNeutral)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonActive)).BeginInit();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // AvgPrice
            // 
            this.AvgPrice.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.AvgPrice.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.AvgPrice.Location = new System.Drawing.Point(95, 370);
            this.AvgPrice.Name = "AvgPrice";
            this.AvgPrice.Size = new System.Drawing.Size(323, 23);
            this.AvgPrice.TabIndex = 11;
            this.AvgPrice.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // TotalShares
            // 
            this.TotalShares.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.TotalShares.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TotalShares.Location = new System.Drawing.Point(95, 338);
            this.TotalShares.Name = "TotalShares";
            this.TotalShares.Size = new System.Drawing.Size(323, 23);
            this.TotalShares.TabIndex = 10;
            this.TotalShares.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(15, 370);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(74, 23);
            this.label3.TabIndex = 2;
            this.label3.Text = "Avg Price";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(6, 338);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(83, 23);
            this.label2.TabIndex = 1;
            this.label2.Text = "Total Shares";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // tradeGrid
            // 
            this.tradeGrid.BackColor = System.Drawing.SystemColors.Window;
            this.tradeGrid.Location = new System.Drawing.Point(6, 115);
            this.tradeGrid.Name = "tradeGrid";
            this.tradeGrid.Size = new System.Drawing.Size(350, 277);
            this.tradeGrid.TabIndex = 6;
            this.tradeGrid.Text = "gridGroupingControl1";
            this.tradeGrid.VersionInfo = "4.102.0.62";
            // 
            // recapGrid
            // 
            this.recapGrid.BackColor = System.Drawing.SystemColors.Window;
            this.recapGrid.Location = new System.Drawing.Point(6, 19);
            this.recapGrid.Name = "recapGrid";
            this.recapGrid.Size = new System.Drawing.Size(412, 309);
            this.recapGrid.TabIndex = 7;
            this.recapGrid.Text = "gridGroupingControl1";
            this.recapGrid.VersionInfo = "4.102.0.62";
            // 
            // sharesTextBox
            // 
            this.sharesTextBox.IntegerValue = ((long)(0));
            this.sharesTextBox.Location = new System.Drawing.Point(55, 28);
            this.sharesTextBox.Name = "sharesTextBox";
            this.sharesTextBox.NegativeInputPendingOnSelectAll = false;
            this.sharesTextBox.NullString = "0";
            this.sharesTextBox.Size = new System.Drawing.Size(221, 20);
            this.sharesTextBox.TabIndex = 8;
            // 
            // priceTextBox
            // 
            this.priceTextBox.CurrencyDecimalDigits = 7;
            this.priceTextBox.CurrencySymbol = "";
            this.priceTextBox.DecimalValue = new decimal(new int[] {
            0,
            0,
            0,
            458752});
            this.priceTextBox.Location = new System.Drawing.Point(55, 54);
            this.priceTextBox.Name = "priceTextBox";
            this.priceTextBox.NegativeInputPendingOnSelectAll = false;
            this.priceTextBox.NullString = "0";
            this.priceTextBox.Size = new System.Drawing.Size(221, 20);
            this.priceTextBox.TabIndex = 9;
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(9, 31);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(40, 13);
            this.label4.TabIndex = 10;
            this.label4.Text = "Shares";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(18, 57);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(31, 13);
            this.label5.TabIndex = 11;
            this.label5.Text = "Price";
            // 
            // buttonAdd
            // 
            this.buttonAdd.Location = new System.Drawing.Point(282, 28);
            this.buttonAdd.Name = "buttonAdd";
            this.buttonAdd.Size = new System.Drawing.Size(74, 81);
            this.buttonAdd.TabIndex = 12;
            this.buttonAdd.Text = "Add";
            this.buttonAdd.UseVisualStyleBackColor = true;
            this.buttonAdd.Click += new System.EventHandler(this.button1_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.radioButtonInactive);
            this.groupBox1.Controls.Add(this.radioButtonNeutral);
            this.groupBox1.Controls.Add(this.radioButtonActive);
            this.groupBox1.Controls.Add(this.tradeGrid);
            this.groupBox1.Controls.Add(this.buttonAdd);
            this.groupBox1.Controls.Add(this.sharesTextBox);
            this.groupBox1.Controls.Add(this.label5);
            this.groupBox1.Controls.Add(this.priceTextBox);
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Location = new System.Drawing.Point(12, 99);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(362, 398);
            this.groupBox1.TabIndex = 13;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Trade List";
            // 
            // radioButtonInactive
            // 
            this.radioButtonInactive.BorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonInactive.Checked = false;
            this.radioButtonInactive.CheckedInt = 1;
            this.radioButtonInactive.CheckedString = "Checked";
            this.radioButtonInactive.Enabled = false;
            this.radioButtonInactive.GradientEnd = System.Drawing.SystemColors.ControlDark;
            this.radioButtonInactive.GradientStart = System.Drawing.SystemColors.Control;
            this.radioButtonInactive.HotBorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonInactive.ImageCheckBoxSize = new System.Drawing.Size(13, 13);
            this.radioButtonInactive.Location = new System.Drawing.Point(117, 80);
            this.radioButtonInactive.Name = "radioButtonInactive";
            this.radioButtonInactive.ShadowColor = System.Drawing.Color.Black;
            this.radioButtonInactive.ShadowOffset = new System.Drawing.Point(2, 2);
            this.radioButtonInactive.Size = new System.Drawing.Size(64, 21);
            this.radioButtonInactive.StretchImage = false;
            this.radioButtonInactive.TabIndex = 18;
            this.radioButtonInactive.Text = "Inactive";
            this.radioButtonInactive.ThemesEnabled = false;
            this.radioButtonInactive.UncheckedInt = 0;
            this.radioButtonInactive.UncheckedString = "Unchecked";
            // 
            // radioButtonNeutral
            // 
            this.radioButtonNeutral.BorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonNeutral.Checked = false;
            this.radioButtonNeutral.CheckedInt = 1;
            this.radioButtonNeutral.CheckedString = "Checked";
            this.radioButtonNeutral.Enabled = false;
            this.radioButtonNeutral.GradientEnd = System.Drawing.SystemColors.ControlDark;
            this.radioButtonNeutral.GradientStart = System.Drawing.SystemColors.Control;
            this.radioButtonNeutral.HotBorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonNeutral.ImageCheckBoxSize = new System.Drawing.Size(13, 13);
            this.radioButtonNeutral.Location = new System.Drawing.Point(187, 80);
            this.radioButtonNeutral.Name = "radioButtonNeutral";
            this.radioButtonNeutral.ShadowColor = System.Drawing.Color.Black;
            this.radioButtonNeutral.ShadowOffset = new System.Drawing.Point(2, 2);
            this.radioButtonNeutral.Size = new System.Drawing.Size(73, 21);
            this.radioButtonNeutral.StretchImage = false;
            this.radioButtonNeutral.TabIndex = 17;
            this.radioButtonNeutral.Text = "Neutral";
            this.radioButtonNeutral.ThemesEnabled = false;
            this.radioButtonNeutral.UncheckedInt = 0;
            this.radioButtonNeutral.UncheckedString = "Unchecked";
            // 
            // radioButtonActive
            // 
            this.radioButtonActive.BorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonActive.Checked = true;
            this.radioButtonActive.CheckedInt = 1;
            this.radioButtonActive.CheckedString = "Checked";
            this.radioButtonActive.GradientEnd = System.Drawing.SystemColors.ControlDark;
            this.radioButtonActive.GradientStart = System.Drawing.SystemColors.Control;
            this.radioButtonActive.HotBorderColor = System.Drawing.SystemColors.WindowFrame;
            this.radioButtonActive.ImageCheckBoxSize = new System.Drawing.Size(13, 13);
            this.radioButtonActive.Location = new System.Drawing.Point(55, 80);
            this.radioButtonActive.Name = "radioButtonActive";
            this.radioButtonActive.ShadowColor = System.Drawing.Color.Black;
            this.radioButtonActive.ShadowOffset = new System.Drawing.Point(2, 2);
            this.radioButtonActive.Size = new System.Drawing.Size(56, 21);
            this.radioButtonActive.StretchImage = false;
            this.radioButtonActive.TabIndex = 16;
            this.radioButtonActive.Text = "Active";
            this.radioButtonActive.ThemesEnabled = false;
            this.radioButtonActive.UncheckedInt = 0;
            this.radioButtonActive.UncheckedString = "Unchecked";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.AvgPrice);
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.recapGrid);
            this.groupBox2.Controls.Add(this.TotalShares);
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Location = new System.Drawing.Point(380, 99);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(424, 398);
            this.groupBox2.TabIndex = 14;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Recap List";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(12, 9);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(418, 13);
            this.label1.TabIndex = 15;
            this.label1.Text = "Trade List shows individual trades.  Recap List shows Trade List data grouped by " +
                "price.";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(12, 43);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(351, 13);
            this.label6.TabIndex = 16;
            this.label6.Text = "So if Trade List has 2 rows, 100 shares @ $150 and 200 shares @ $150,";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(12, 60);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(288, 13);
            this.label7.TabIndex = 17;
            this.label7.Text = "then the Recap List will show 1 row for 300 shares @ $150.";
            // 
            // Form2
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(816, 508);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Name = "Form2";
            ((System.ComponentModel.ISupportInitialize)(this.tradeGrid)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.recapGrid)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.sharesTextBox)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.priceTextBox)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonInactive)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonNeutral)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButtonActive)).EndInit();
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

	    }
	    #endregion

        private void SetupGroupingEngine()
	    {
            groupingEngine.SetSourceList(tradeList);
            groupingEngine.RecordAsDisplayElements = true;
            groupingEngine.TableDescriptor.Summaries.Add("TotalShares", "Shares", SummaryType.Int32Aggregate);
            groupingEngine.TableDescriptor.Summaries.Add("TotalPrice_X_Shares", "Price_X_Shares", SummaryType.DoubleAggregate);
            groupingEngine.TableDescriptor.Summaries.Add("PriceGroup", "Price", SummaryType.DoubleAggregate);
            groupingEngine.Table.TableDescriptor.GroupedColumns.Add("Price");
            groupingEngine.Table.FixTopLevelCounters();
	    }

        private void SetupSummaryEngine()
        {
            summaryEngine.SetSourceList(tradeList);
            summaryEngine.RecordAsDisplayElements = true;
            summaryEngine.TableDescriptor.Summaries.Add("TotalShares", "Shares", SummaryType.Int32Aggregate);
            summaryEngine.TableDescriptor.Summaries.Add("TotalPrice_X_Shares", "Price_X_Shares", SummaryType.DoubleAggregate);
            summaryEngine.Table.FixTopLevelCounters();

            // add filters to engine
            FilterCondition fc1 = new FilterCondition(FilterCompareOperator.Equals, TradeState.Active);
            FilterCondition fc2 = new FilterCondition(FilterCompareOperator.Equals, TradeState.Inactive);
            RecordFilterDescriptor rfd = new RecordFilterDescriptor();
            rfd.Name = "TradeState";
            rfd.LogicalOperator = FilterLogicalOperator.Or;
            rfd.Conditions.Add(fc1);
            rfd.Conditions.Add(fc2);
            summaryEngine.TableDescriptor.RecordFilters.Add(rfd);
        }
	    
	    private void SubscribeToEvents()
	    {
            groupingEngine.SourceListListChangedCompleted += new TableListChangedEventHandler(engine_SourceListListChangedCompleted);
	    }
 
        private void PopulateData()
	    {
            //populate the trade list
            tradeList.Add(new Trade(100, 150.0000000, TradeState.Active));
            tradeList.Add(new Trade(100, 152.0000000, TradeState.Active));
            tradeList.Add(new Trade(100, 10000.0000000, TradeState.Active));
            tradeList.Add(new Trade(100, 150.0000000, TradeState.Active));
            tradeList.Add(new Trade(100, 152.0000000, TradeState.Active));
            tradeList.Add(new Trade(100, 10000.0000000, TradeState.Active));
            
	        //set grid data sources
	        tradeGrid.DataSource = tradeList;
	        recapGrid.DataSource = recapList;
	    }

	    private void RefreshRecapAndTotals()
	    {
            ///////////////////////////////////////////////////////////////////////////
	        // use grouping engine to populate the recapList/recapGrid
            ///////////////////////////////////////////////////////////////////////////
            
            groupingEngine.Table.FixTopLevelCounters();
            
	        recapList.Clear();
	        recapGrid.DataSource = null;
            foreach (Element o in groupingEngine.Table.Elements)
	        {
	            if (o is SummarySection)
	            {
	                SummarySection ss = (SummarySection)o;

	                if (ss.GroupLevel > 0)
	                {
	                    ITreeTableSummary totalShares = ss.ParentGroup.GetSummary("TotalShares");
	                    ITreeTableSummary priceGroup = ss.ParentGroup.GetSummary("PriceGroup");

	                    DoubleAggregateSummary pg = priceGroup as DoubleAggregateSummary;
	                    Int32AggregateSummary ts = totalShares as Int32AggregateSummary;

                        recapList.Add(new Recap(ts.Sum, pg.Average));
	                }
	            }
	        }
	        recapGrid.DataSource = recapList;

	        ///////////////////////////////////////////////////////////////////////////
            // use summary engine to populate the total shares and average price fields
            ///////////////////////////////////////////////////////////////////////////
            summaryEngine.SetSourceList(null);
            summaryEngine.SetSourceList(tradeList);
	        
	        summaryEngine.Table.FixTopLevelCounters();
	        
            ITreeTableSummary[] summaries = summaryEngine.Table.TopLevelGroup.GetSummaries(summaryEngine.Table);
            SummaryDescriptorCollection sdc = summaryEngine.Table.TableDescriptor.Summaries;
			
	        Int32AggregateSummary summary1 = summaries[sdc.IndexOf(sdc["TotalShares"])] as Int32AggregateSummary;
	        TotalShares.Text = summary1.Sum.ToString();

            DoubleAggregateSummary summary2 = summaries[sdc.IndexOf(sdc["TotalPrice_X_Shares"])] as DoubleAggregateSummary;
	        AvgPrice.Text = (summary2.Sum /summary1.Sum).ToString();
	    }

        void engine_SourceListListChangedCompleted(object sender, TableListChangedEventArgs e)
        {
            RefreshRecapAndTotals();
        }
   
	    private void button1_Click(object sender, EventArgs e)
	    {
            TradeState ts = TradeState.Active;
            if (radioButtonActive.Checked) ts = TradeState.Active;
            if (radioButtonInactive.Checked) ts = TradeState.Inactive;
            if (radioButtonNeutral.Checked) ts = TradeState.Neutral;
	        tradeList.Add(new Trade(sharesTextBox.IntegerValue, (double)priceTextBox.DecimalValue, ts));
	    }
    }
}
